{ ... }@args:

with builtins;

let
  fix = f: let x = f x; in x;

  readTree = import ./nix/readtree.nix {};

  # Tracking nixos-unstable as of 2021-08-11.
  nixpkgsCommit = "e26c0ffdb013cd378fc2528a44689a8bf35d2a6c";
  nixpkgsSrc = fetchTarball {
    url = "https://github.com/NixOS/nixpkgs/archive/${nixpkgsCommit}.tar.gz";
    sha256 = "1b33hw35fqb9rzszdg5jpiyfvhx2cxpv0qrkyr19zkdpdahzdbss";
  };
  nixpkgs = import nixpkgsSrc {
    config.allowUnfree = true;
    config.allowBroken = true;
  };

in fix (self: rec {
  config = {
    hscloud = self // {
      root = ./.;
    };
    pkgs = nixpkgs;
    pkgsSrc = nixpkgsSrc;

    inherit (nixpkgs) lib stdenv;
  };

  bgpwtf = readTree config ./bgpwtf;
  cluster = readTree config ./cluster;
  hswaw = readTree config ./hswaw;
  ops = readTree config ./ops;

  pkgs = nixpkgs;
})
